package Chain;
use strict;

sub new {
	my $class = shift;
	my $self = {};
	bless($self,$class);

	$self->{input}  = {};
	$self->{output} = {};

	$self->{links}   = [];
	$self->{LUMs}    = [];
	$self->{rLUMseq} = [];

	$self->{winner} = "";
	
	return $self;
}

# read and write methods
sub input  {my $self = shift; if (@_) {$self->{input}=shift;  }; return $self->{input}  }
sub winner {my $self = shift; if (@_) {$self->{winner}=shift; }; return $self->{winner} }

# read-only methods
sub links   { my $self = shift; return $self->{links}   }
sub LUMs    { my $self = shift; return $self->{LUMs}    }
sub rLUMseq { my $self = shift; return $self->{rLUMseq} }
sub output  { my $self = shift; return ${$self->{links}}[$#{$self->{links}}] }; # returns the last link of the chain

sub copyChain {

	my $inChain = shift;
	my $newLink = shift;
	
	my $outChain = Chain->new();
	$outChain->input($inChain->input());
	$outChain->pushLink($_->copyLink(1)) for (@{$inChain->links()}) ;
	$outChain->pushLink($newLink);
	return $outChain;
}

# adds a link to the chain
sub pushLink { 
	my $self = shift;
	my $inLink = shift;
	push(@{$self->links()},$inLink);
	push(@{$self->LUMs()},$inLink->LUM()) if ($inLink->LUM());
}




1