#!/usr/bin/perl -w

use strict;
use warnings;

use CGI;
my $q = new CGI;
use CGI::Cookie;
use URI::Escape;

use Fcntl qw(:flock);

use Phoneme;
use Link;
use MakeHTML;






# check for submitted form

my $foundUser = 0;
my $errorStr = "";
my $loggedInStr = "";
my $sourcepage = $q->param("keywords") || $q->param("sourcepage") || "";

if ($q->param("email") or $q->param("pass") or $q->param("remember")) {

	die "The program aborted because of unexpected characters in the email input. $!"         if (($q->param("email") =~ /[\{\}]/)      or (length($q->param("email"))>60));
	die "The program aborted because of unexpected characters in the password input. $!"      if (($q->param("pass") =~ /[^A-Za-z0-9]/) or (length($q->param("pass"))>30) );
	die "The program aborted because of unexpected characters in the 'remember me' input. $!" if ($q->param("remember") =~ /[^01]/);
	die "The program aborted because of unexpected characters in the 'sourcepage' input. $!"  unless ($q->param("sourcepage") eq "input" or $q->param("sourcepage") eq "CON" or $q->param("sourcepage") eq "");
	
	my $email = $q->param("email");
	my $pass  = $q->param("pass");
	my $name;
	my $affil;
	
	if (open (USERS, "<data/users.cgi")) { # or die "Can't read user information. $!";
		flock(USERS, LOCK_SH);
		while (<USERS>) {
			if (index($_,$email.";")==0 and index($_,"password=".$pass.";")>-1) {
				$foundUser = 1;
				last;
			}
		}
		close(USERS);
	} else {
		$errorStr = "User file missing; can't find user information.";
	}
	
	if ($foundUser) {
		$loggedInStr = "<DIV CLASS=title>You were successfully logged in.</DIV>";
		my $permanent = $q->param("remember") || 0;
	  
		if ($permanent) {
			# write cookie
			my $c = new CGI::Cookie(-name    =>  'userEmail',
							-value   =>  $email,
							-expires =>  '+200M',
						     );
			print "Set-Cookie: $c\n";
			$loggedInStr .= "You will stay logged in until you click 'Log out'.";
		} else {
			# write cookie
			my $c = new CGI::Cookie(-name    =>  'userEmail',
							-value   =>  $email,
						     );
			print "Set-Cookie: $c\n";
			$loggedInStr .= "You will stay logged in until you close your browser window.";
		}
		
		if ($sourcepage eq "input" or $sourcepage eq "CON") {
			print $q->redirect(-uri=>'save.cgi?'.$sourcepage);
		}
	    
	} else {
		$errorStr = "Invalid ID or password. Please try again." unless ($errorStr);
	}
}

# if user exists, go to saveInput or saveCON


# if user doesn't exist, give error message

#if ($q->param('email')

# create the body of the page
print $q->header;
print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<HEAD>
	<TITLE>CCamelOT - An OT-CC implementation</TITLE>
	
	<LINK rel="stylesheet" type="text/css" href="mich.css" />
	<META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	
	<SCRIPT src="toolbox.js" type="text/javascript"></SCRIPT>
</HEAD>

<BODY LEFTMARGIN=0 TOPMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>

EOF

# read nav bar
open (NAV, "<navbar.txt") or die "Can't read navbar. $!";
print while (<NAV>);
close(NAV);

print "\n<DIV CLASS='pagebody'>\n\n";

if ($sourcepage eq "input" or $sourcepage eq "CON") {
    
	print "<SPAN STYLE='font-size:120%;line-height:150%;'>To post your data, publicly or privately, you have to be a registered user who is logged in.</SPAN><BR><BR>";
    
}


if ($loggedInStr) {

	print $loggedInStr , "<BR><BR>";
    
    
} else {

	print <<"	EOF";

	<DIV CLASS=title>Registered users, please log in:</DIV>
	<BR>
	EOF

	print "<SPAN CLASS='errorMsg'>" , $errorStr , "</SPAN><BR>" if ($errorStr);

	print <<"	EOF";
	<FORM NAME="login" METHOD="post" ACTION="login.cgi">
	<INPUT TYPE="hidden" NAME="sourcepage" VALUE="$sourcepage">
	<TABLE>
	<TR>
		<TD>Email:   </TD><TD><INPUT TYPE=text     NAME="email" CLASS='textInput' VALUE="" SIZE=30 STYLE="width:15em;" MAXLENGTH=60></TD>
	</TR>
	<TR>
		<TD>Password:</TD><TD><INPUT TYPE=password NAME="pass"  CLASS='textInput' VALUE="" SIZE=30 STYLE="width:15em;" MAXLENGTH=30></TD>
	</TR>
	<TR>
		<TD>&nbsp;</TD><TD><INPUT TYPE=checkbox NAME="remember"  VALUE="1" STYLE="font-size:120%;" CHECKED> Keep me logged in on this computer</TD>
	</TR>
	<TR>
		<TD>&nbsp;</TD><TD><INPUT TYPE=submit VALUE=" Log in "></TD>
	</TR>
	<TR>
		<TD>&nbsp;</TD><TD><SPAN CLASS="regInstructions">Forgot your password? Email
		
		<SCRIPT type="text/javascript" language="javascript">
		<!--
		// eMail Obfuscator Script 1.31 by Tim Williams - freeware
		    {     document.write(String.fromCharCode(60,97,32,104,114,101,102,61,34,109,97,105,108,116,111,58,109,105,99,104,97,101,108,64,108,105,110,103,117,105,115,116,46,117,109,97,115,115,46,101,100,117,34,62,109,105,99,104,97,101,108,64,108,105,110,103,117,105,115,116,46,117,109,97,115,115,46,101,100,117,60,47,97,62))
		     }
		//-->
		</SCRIPT>
		
		and ask for it<SPAN></TD>
	</TR>
	</TABLE>
	</FORM>
	
	<BR>
	
	
	<DIV CLASS=title>New users, please <A HREF="register.cgi">register</A>.</DIV>
	<BR>
	EOF
}

print "</DIV>";

# read footer
open (FTR, "<footer.txt") or die "Can't read footer. $!";
print while (<FTR>);
close(FTR);

print "\n</BODY>\n</HTML>";
