#!/usr/bin/perl -w

use strict;
use warnings;

use CGI;
my $q = new CGI;


# create the body of the page
print $q->header;
print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<HEAD>
    <TITLE>CCamelOT - An OT-CC implementation</TITLE>
    
    <LINK rel="stylesheet" type="text/css" href="mich.css" />
    <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />

	<SCRIPT src="toolbox.js" type="text/javascript"></SCRIPT>
	<SCRIPT>
		function toggleView(elem) {
			if (document.getElementById) {
				document.getElementById(elem).style.display = (document.getElementById(elem).style.display == "block") ? "none" : "block";
			}
		}
	    
		function showDiv() {
			if (location.href.indexOf("#")!=-1) {
				var displayDiv = location.href.substr(location.href.indexOf("#")+1,location.href.length);
				if (document.getElementById(displayDiv)) toggleView(displayDiv);
			}
		}
		
		function init() {
			document.getElementById("ranking_tab").className = "navOn";
			document.getElementById("needConTab").className = "menuOn" ;
		}
	
	</SCRIPT>

</HEAD>

<BODY LEFTMARGIN=0 TOPMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0 onLoad="init();showDiv()">
EOF


# read nav bar
open (NAV, "<navbar.txt") or die "Can't read navbar. $!";
print while (<NAV>);
close(NAV);

my $menuStr;
open (NAV, "<ranking_menu.txt") or die "Can't read ranking menu. $!";
print while (<NAV>);
close(NAV);

print <<"EOF";

<DIV CLASS="menuMain">
	<BR>
	Maybe I can add the constraint you want for you,<BR>
	but wouldn't you like to do it yourself?<BR>
	<BR>

	<A HREF="javascript:toggleView('myself')">Yeah, let me write my own constraint</A><BR>
	<BR>
	<DIV CLASS="helpDiv" ID="myself">
		You need to know some basic Perl, and you need access to a CGI server. <A HREF="javascript:toggleView('technical')">Tell me how!</A><BR>

		<DIV CLASS="helpDiv" ID="technical">
			<BR>
			Perl:<BR>
			A working environment for Perl that works on several operating systems is free from <A HREF="http://www.activestate.com/Products/ActivePerl/">activestate.com</A>. The installation comes with documentation and a tutorial that helps you get started. I also found the Perl Cookbook (<A HREF="http://www.amazon.com/exec/obidos/tg/detail/-/1565922433/104-3536552-3380704?v=glance">First edition</A>) (<A HREF="http://www.amazon.com/gp/product/0596003137/002-8677853-1850408?v=glance&n=283155&s=books&v=glance">Second edition</A>)really helpful (Thanks, Kathryn!).<BR>
			<BR>
			Server:<BR>
			You can run Perl programs on your computer from the command line, and get a textual result. This is great. However, this won't work for CCamelOT, because its output is HTML pages. So you need to run CCamelOT on a server.<BR>
			<BR>
			You can run the server on your own computer. If you are running Windows XP, go to control panel -&gt; add or remove programs -&gt; add/remove windows components (on the left) -&gt;  internet information services (IIS). Install IIS. When you are done, you control the server from the control panel -&gt; administrative tools -&gt; internet information services. The Perl documentation explains how to make Perl scripts run on your IIS server.<BR>
			<BR>
			If you can't or don't want to use IIS (because you have a Mac or whatever), you can install the free <A HREF="http://httpd.apache.org/">Apache</A> server. It doesn't have a graphical interface, so it's harder if you haven't dealt with servers before. The Perl documention and the Apache documention explain how to run CGI scripts on your Apache server. You will also need to go to all the CGI files of CCamelOT and change the "shebang" line (it's explained in the Perl documentation).<BR>
			<BR>
			A third option is to run CCamelOT on a CGI server that your university runs. It's very likely that your university provides such a server. It's less convenient, since you will have to FTP your script to the server each time you make a change, but if you can't get your own server to run, it's better than nothing.<BR>
			<BR>
			If you are trying to install a server and you get stuck, use google to find an answer to your question (usually in some discussion forum). The truth is out there.<BR>
		</DIV>
	
		<BR>
		Just download the zipped <A HREF="CCamelOT.zip">source</A> and play with it. Share your constraints with our Perl-challanged friends by sending them to me, and I will post them to the site.<BR>
		<BR>
		Some idea of what you are getting into:<BR>
		Each constraint is a subroutine that gets an input and an output, and returns the number of violations. It should be easy to copy one of the existing constraints and fiddle with it a little. You will have access to the input's and output's segments, moras, syllables and features (except that the input won't have syllables). You will find the constraints, and some more instructions, in the file Constraints.pm.<BR>
		<BR>
		Constaints that refer to tone, stress, or any other kind of structure that isn't there yet will be more demanding. You will have to fiddle with the structure of the linguistic forms (in the file Link.pm).<BR>
		<BR>
		Other constraints, like OO-Faith, change the way the derivation works, so adding them might be demanding. Most of the derivation is in the subroutine "derive", in the file Link.pm.<BR>
		<BR>
    	</DIV>

	<A HREF="javascript:toggleView('Please')">Please add a constraint for me</A><BR>
	<BR>
	<DIV CLASS="helpDiv" ID="Please">
		If you think I can implement a constraint that you need, please write to me:<BR>
		Michael Becker 
		&lt;<SCRIPT type="text/javascript" language="javascript">
		<!--
		// eMail Obfuscator Script 1.31 by Tim Williams - freeware
			document.write(String.fromCharCode(60,97,32,104,114,101,102,61,34,109,97,105,108,116,111,58,109,105,99,104,97,101,108,64,108,105,110,103,117,105,115,116,46,117,109,97,115,115,46,101,100,117,34,62,109,105,99,104,97,101,108,64,108,105,110,103,117,105,115,116,46,117,109,97,115,115,46,101,100,117,60,47,97,62));
		//-->
		</SCRIPT>&gt;<BR>
		Please tell me <STRONG>exactly</STRONG> what you want the constraint to do.<BR>
		<BR>
		Simple markedness, I-O faithfulness, positional markedness and/or I-O faithfulness, and conjoined
		versions of these are probably easy for me to add.<BR>
		<BR>
		No funny stuff at the moment, i.e.:<BR>
		No OO-Faith (including anti-Faith) or BR-Faith at the moment.<BR>
		No sympathy constraints.<BR>
		<BR>
		Other constraints will be coming soon. Stay tuned.<BR>
		<BR>
	</DIV>

</DIV>
EOF

# read footer
open (FTR, "<footer.txt") or die "Can't read footer. $!";
print while (<FTR>);
close(FTR);

print <<"EOF";

</BODY>
</HTML>

EOF
