#!/usr/bin/perl -w

use strict;
use warnings;

use CGI;
my $q = new CGI;
use CGI::Cookie;
use URI::Escape;

use Fcntl qw(:flock);


# check for submitted form
my $errorStr = "";
my $addedUser = 0;
my $existUser = 0;

my $temp;

my $email  = "";
my $email2 = "";
my $name   = "";
my $affil  = "";

if ($q->param) {

	die "The program aborted because of unexpected characters in the email input.       $!" if (($q->param("email")  =~ /[\{\};]/) or (length($q->param("email")) >60));
	die "The program aborted because of unexpected characters in the email input.       $!" if (($q->param("email2") =~ /[\{\};]/) or (length($q->param("email2"))>60));
	die "The program aborted because of unexpected characters in the name input.        $!" if (($q->param("name")   =~ /[\{\};]/) or (length($q->param("name"))  >60));
	die "The program aborted because of unexpected characters in the affiliation input. $!" if (($q->param("affil")  =~ /[\{\};]/) or (length($q->param("affil")) >60));
	
	
	$email  = $q->param("email")  || "";
	$email2 = $q->param("email2") || "";
	$name   = $q->param("name")   || "";
	$affil  = $q->param("affil")  || "";
	
	if (length($email)<1) {
		$errorStr = "Please enter your email if you want to register";
	}
	if (length($name)<1) {
		$errorStr = "Please enter your name if you want to register";
	}
	if ($email ne $email2) {
		$errorStr = "Please enter the same email address twice.";
		$email = $email2 = ""
	}
	
	if ($errorStr eq "") {
		# check if user doesn't exist already
		open (USERS, "<data/users.cgi") or $errorStr = "User file missing; can't update.";
		flock(USERS, LOCK_SH);
		while (<USERS>) {
			if (index($_,$email)==0) {
				$existUser = 1;
				last;
			}
		}
		close(USERS);
	    
		unless ($existUser or $errorStr) {

			# add user to the database, send email
			my $randPass;
			while (length($randPass) < 4) {
			    $randPass .= chr(97+int(rand(26)));
			}
			my $time = localtime ;
			my $userStr = "$email;password=$randPass;name=$name;affiliation=$affil;time=$time;\n";
	    
			open (USERS, ">>data/users.cgi") or die "Can't write to user file. $!";
			flock(USERS, LOCK_EX);
			print USERS $userStr;
			close(USERS);
			
			my $mailpath = '/usr/lib/sendmail -i -t';
			open (MAIL,"|$mailpath -t") || die "Can't find email server, can't send email $!";
			
			print MAIL "To: $name <$email>\n";
			print MAIL "From: Michael Becker <michael\@linguist.umass.edu>\n";
			print MAIL "Subject: Your CCamelOT password \n";
			
			print MAIL "Thank you for registering to CCamelOT, an OT-CC implementation.\n\n";
			print MAIL "You were registered using the following details:\n";
			print MAIL "Email:       $email\n";
			print MAIL "Name:        $name\n";
			print MAIL "Affiliation: $affil\n" if ($affil);
	    
			print MAIL "\nYour password is: $randPass\n";
			print MAIL "You should be able to use it immediately. ";
			print MAIL "Please contact me if you encounter any difficulties or have any other questions.\n\n";
	    
			print MAIL "Best,\nMichael Becker\nUMass Amherst\n";
			print MAIL "http://people.umass.edu/mbe/\n";
			
			close(MAIL);
	    
			$addedUser = 1;
		}
	}
}


# create the body of the page
print $q->header;
print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<HEAD>
	<TITLE>CCamelOT - An OT-CC implementation</TITLE>
	
	<LINK rel="stylesheet" type="text/css" href="mich.css" />
	<META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	
	<SCRIPT src="toolbox.js" type="text/javascript"></SCRIPT>
</HEAD>

<BODY LEFTMARGIN=0 TOPMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>

EOF

# read nav bar
open (NAV, "<navbar.txt") or die "Can't read navbar. $!";
print while (<NAV>);
close(NAV);

print "\n<DIV CLASS='pagebody'>\n\n";

if ($addedUser) {

	print <<"	EOF";
		<DIV CLASS=title>You were successfully registered.</DIV>
		An email with your password was sent to
		the email address you provided.<BR>
		<BR>
		<BR>
	EOF
    
} else {

	if ($existUser) {

		print <<"		EOF";
			<DIV CLASS=title>A user with the email address you provided already exists in the system.</DIV>
			<BR>
			If you have just registered and mistakenly hit the 'refresh' button, don't worry:<BR>
			An email with your password was sent to the email address you provided.<BR><BR>
			Otherwise, <A HREF='register.cgi'>register</A> again with a different email address, or email
			<SCRIPT type="text/javascript" language="javascript">
			<!--
			// eMail Obfuscator Script 1.31 by Tim Williams - freeware
			    {     document.write(String.fromCharCode(60,97,32,104,114,101,102,61,34,109,97,105,108,116,111,58,109,105,99,104,97,101,108,64,108,105,110,103,117,105,115,116,46,117,109,97,115,115,46,101,100,117,34,62,109,105,99,104,97,101,108,64,108,105,110,103,117,105,115,116,46,117,109,97,115,115,46,101,100,117,60,47,97,62))
			     }
			//-->
			</SCRIPT>
			and explain what the problem is.<BR>
			<BR>
			<BR>
		
		EOF

	} else {

		print <<"		EOF";
		
		<DIV CLASS=title>New users, please register:</DIV>
		<BR>
		EOF
	
		print "<SPAN CLASS='errorMsg'>" , $errorStr , "</SPAN><BR>" if ($errorStr);
	
		print <<"		EOF";
		
		<FORM NAME="register" METHOD="post" ACTION="register.cgi">
		<TABLE BORDER=0 CELLPADDING=3>
		<TR VALIGN=top>
			<TD>*Email:</TD>
			<TD>
				<INPUT TYPE=text     NAME="email"  VALUE="$email"  SIZE=30 CLASS='textInput' STYLE="width:15em;" MAXLENGTH=60><BR>
				<DIV CLASS="regInstructions">
					A valid email address to which your password will be sent.<BR>
					It will be visible to others if you choose to make public postings.</SPAN><BR>
					The eMail Obfuscator by Tim Williams is used in all pages where emails are shown.
				</DIV>
			</TD>
		</TR>
		<TR VALIGN=top>
			<TD>*Email:</TD>
			<TD>
				<INPUT TYPE=text     NAME="email2" VALUE="$email2" SIZE=30 CLASS='textInput' STYLE="width:15em;" MAXLENGTH=60><BR>
				<SPAN CLASS="regInstructions">Please re-type your email to minimize the chance of error.<SPAN>
			</TD>
		</TR>
		<TR VALIGN=top>
			<TD>*Name:</TD>
			<TD>
				<INPUT TYPE=text     NAME="name"   VALUE="$name"   SIZE=30 CLASS='textInput' STYLE="width:15em;" MAXLENGTH=60><BR>
				<SPAN CLASS="regInstructions">Your real name please. It will be visible to others if you choose to make public postings.<SPAN>
			</TD>
		</TR>
		<TR VALIGN=top>
			<TD>Affiliation:    </TD>
			<TD>
				<INPUT TYPE=text     NAME="affil"  VALUE="$affil"  SIZE=30 CLASS='textInput' STYLE="width:15em;" MAXLENGTH=60><BR>
				<SPAN CLASS="regInstructions">Optional. Your school or place of work.<SPAN>
			</TD>
		</TR>
		<TR VALIGN=top>
			<TD>&nbsp;</TD>
			<TD><INPUT TYPE="submit" VALUE=" Register " onClick="return checkForm([this.form.affil,this.form.name,this.form.email,this.form.email2])"></TD>
		</TR>
		</TABLE>
		</FORM>
		
		
		<DIV CLASS=title>Registered users, please <A HREF="login.cgi">log in</A>.</DIV>
		
		EOF
	}
}

print "</DIV>";

# read footer
open (FTR, "<footer.txt") or die "Can't read footer. $!";
print while (<FTR>);
close(FTR);

print <<"EOF";
</BODY>
</HTML>

EOF
